#define HEAP_DEGREE  3
#define NILL        -1

long h_current_pos,
     h_new_pos,
     h_pos,
     h_last_pos;

itemT *item_j,
      *item_k;

timeType
     key_k,
     key_min;


/* internal definition */
#define PUT_TO_POS_IN_HEAP( h, item_i, pos )\
{\
h.item[pos]        = item_i;\
item_i -> heap_pos = pos;\
}

#define makeHeap( h, n )\
{\
h.size = 0;\
h.item = (itemT **) calloc (( n+1 ), sizeof(itemT *));\
}

#define nonEmptyH( h )  ( h.size > 0 )

#define ITEM_IN_HEAP( item_i ) ( item_i -> heap_pos != NILL )

#define decreaseKey( h, item_i, key_i ) \
{\
for ( h_current_pos =  item_i -> heap_pos;\
      h_current_pos > 0;\
      h_current_pos = h_new_pos\
    )\
      {\
        h_new_pos = ( h_current_pos - 1 ) / HEAP_DEGREE;\
\
        item_j = h.item[h_new_pos];\
        if ( key_i  >=  item_j -> key ) break;\
\
        PUT_TO_POS_IN_HEAP ( h, item_j, h_current_pos )\
      }\
\
PUT_TO_POS_IN_HEAP ( h, item_i, h_current_pos )\
}

#define hInsert( h, item_i )\
{\
PUT_TO_POS_IN_HEAP ( h, item_i, h.size )\
h.size ++;\
decreaseKey ( h, item_i, item_i -> key );\
}

#define extractMin( h, item_0 ) \
{\
item_0             = h.item[0];\
item_0 -> heap_pos = NILL;\
\
h.size -- ;\
\
if ( h.size > 0 )\
  {\
     item_k =  h.item [ h.size ];\
     key_k =  item_k -> key;\
\
     h_current_pos = 0;\
\
     while ( 1 )\
       {\
         h_new_pos = h_current_pos * HEAP_DEGREE  +  1;\
         if ( h_new_pos >= h.size ) break;\
\
         key_min  = h.item[h_new_pos] -> key;\
\
         h_last_pos  = h_new_pos + HEAP_DEGREE;\
	 if ( h_last_pos > h.size ) h_last_pos = h.size;\
\
         for ( h_pos = h_new_pos + 1; h_pos < h_last_pos; h_pos ++ )\
            {\
 	      if ( h.item[h_pos] -> key < key_min )\
		{\
		  h_new_pos = h_pos;\
		  key_min  = h.item[h_pos] -> key;\
		}\
	    }\
\
         if ( key_k <= key_min ) break;\
\
         PUT_TO_POS_IN_HEAP ( h, h.item[h_new_pos], h_current_pos )\
\
         h_current_pos = h_new_pos;\
       }\
\
    PUT_TO_POS_IN_HEAP ( h, item_k, h_current_pos )\
  }\
}

